/************************************************************************/
/* Fichero: bufferfijo.c                                                */
/* Descripcon: fichero que implementa un buffer de playout fijo. Lee   */
/* de un fichero de entrada el retraso en milisegundos escribiendo en   */
/* un fichero un 1 si el paquete se recibe a tiempo o un 0 si no        */
/* Llamada: bufferfijo buffer_delay fich_retrasos fich_transmitidos     */
/************************************************************************/

float Lee_retraso(float *silencio, int *secuencia, FILE *Ifp, FILE *Ofp, FILE *dibujofp);

int Playout_buffer(float *silencio, float *delay, float *PlayoutDelay,\
		   float BufferDelay, int secuencia, FILE *dibujofp);

#define ALFA 0.998002
#define BETA 4
int Playout_exponencial(float *silencio, float *delay, float *PlayoutDelay,\
			float *ref_PlayoutDelay, int secuencia, float *media,\
			float *varianza, FILE *dibujofp);

#define BETAFAST 0.75
int Playout_fastexp(float *silencio, double *delay, double *PlayoutDelay,\
		   double *ref_PlayoutDelay, int secuencia, double *media,\
		   double *varianza, FILE *dibujofp);


#define NORMAL 1
#define IMPULSE 2

typedef struct nodo{
   float n;          
   float delay;         
   struct nodo *sig;
}NODO;

NODO *CreaNodo (float tam_rafaga, float n);
void Enlazaspike(NODO **lcola, NODO *lnodo);
int Playout_spike(float *silencio, NODO *ldelay, float *PlayoutDelay,\
		  float *ref_PlayoutDelay, int secuencia, float *media,\
		  float *varianza, float *var, int *mode, FILE *dibujofp);


void Enlaza_orden(NODO **lcola, float tam_rafaga);

int Playout_minimo(float *silencio, float *delay, float *PlayoutDelay,\
		   float *ref_PlayoutDelay, int secuencia, float *media, \
		   float *varianza, NODO **ldelay, FILE *dibujofp);

void Borra_Lista(NODO **lcola);

int Playout_losscontrol(float *silencio, NODO *ldelay, float target, float *PlayoutDelay, float *ref_PlayoutDelay, int secuencia, FILE *dibujofp);

int Paretomle(float *k, float *alfa, NODO* ldelay, int mos);
float falseposition(int x1, int x2, float xacc, float k, float alfa);
float derivadafuncionMos(float x, float k, float alfa);

int Playout_mos(float *silencio, NODO *ldelay, float *PlayoutDelay, float *ref_PlayoutDelay, int secuencia, FILE *dibujofp);

float funcionMos();
float derivadaMos();
