/************************************************************************/
/* Fichero: encapsulado.h                                               */
/* Descripcon: fichero que contiene los prototipos de las funciones    */
/* usadas por encapsulado.c                                             */
/************************************************************************/

/*********************** Tipos de tramas ********************************/
#define NO_TX '0'
#define ACTIVA '1'
#define SID '2'

#define CABECERA 40    //Bytes de la cabecera de un paquete IP

/************************** G723 ****************************************/
#define T_TRAMA_G723 30      //Codificador g723: tramas de 30ms
#define LOOK_AHEAD_G723 7.5  //Codificador g723: look ahead (preanalisis) de 7.5ms

/************************** G729 ****************************************/
#define T_TRAMA_G729 10      //Codificador g729: tramas de 10ms
#define LOOK_AHEAD_G729 5    //Codificador g729: look ahead (preanalisis) de 5ms

int Encapsulado_RFC(int tasa_empaquetado, int t_trama, float look_ahead, \
		    FILE *Ifp, FILE *Ofp, FILE *retrasofp);

int Encapsulado_Multisid(int tasa_empaquetado, int t_trama, float look_ahead,\
			 FILE *Ifp, FILE *Ofp, FILE *retrasofp);

int Tamano_Cabecera (int t_trama, int sid, int no_tx);
