/************************************************************************/
/* Fichero: loss_control.c                                              */
/************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>  //para usar la funcion fabs (en include-mingw32)

#include "algoritmos.h"

int main( int argc, char *argv[] )
{
   FILE    *Ifp, *Ofp, *dibujofp;            /* I/O File pointers */
   float PlayoutDelay;      // Valor que se va calculando con el algoritmo exponencial
   float ref_PlayoutDelay; // Valor que se ajusta al principio de cada rafaga de voz
   float delay;            // Retraso del paquete leido del fichero
   float silencio;         // Duracion del periodo de silencio
   float target;
   int secuencia;          // Numero de secuencia del paquete recibido
   NODO *ldelay;
   //FILE *borrar = fopen("ploss.txt", "w");
   silencio = 0;
   ldelay = NULL;
   PlayoutDelay = 0;

   if (argc != 5 ) {
      printf("Llamada: %s porcentaje fich_retrasos fich_transmitidos fich_dibujo \n", argv[0]);
      exit(1);
   }
   
   Ifp = fopen( argv[2], "r") ;
   if ( Ifp == NULL ) {
      fprintf(stderr, "Invalid input file name: %s\n", argv[2] ) ;
      exit(1) ;
   }

   Ofp = fopen( argv[3], "w") ;
   if ( Ofp == NULL ) {
      fprintf(stderr, "Can't open output file: %s\n", argv[3] ) ;
      exit(1) ;
   }

   dibujofp = fopen( argv[4], "w") ;
   if ( dibujofp == NULL ) {
      fprintf(stderr, "Can't open output file: %s\n", argv[4] ) ;
      exit(1) ;
   }

   target = atof(argv[1]);
   delay = Lee_retraso(&silencio, &secuencia, Ifp, Ofp, dibujofp);
   silencio = 0;

   Enlaza_orden(&ldelay, delay);  //Primer nodo de la cola
   Playout_losscontrol(&silencio, ldelay, target, &PlayoutDelay, &ref_PlayoutDelay, secuencia, dibujofp);
   ref_PlayoutDelay = PlayoutDelay;
   fputs("1 ", Ofp); // Escribe un 1 en el fichero (el primer paquete se recibe a tiempo)

   delay = Lee_retraso(&silencio, &secuencia, Ifp, Ofp, dibujofp);
   // se lee el fichero completo
   //feof: devuelve un valor distinto de cero si ha llegado al final del archivo 
   //ferror: devuelve un valor distinto de cero si se ha producido algun error
   while(!feof(Ifp) && !ferror(Ifp) && !ferror(Ofp)){
      Enlaza_orden(&ldelay, delay);
      Playout_losscontrol(&silencio, ldelay, target, &PlayoutDelay, &ref_PlayoutDelay, secuencia, dibujofp);
	 
      if (delay < ref_PlayoutDelay){   // el paquete se recibe a tiempo
         fputs("1 ", Ofp);
      }
      else {                       // el paquete no llega a transmitirse
         fputs("0 ", Ofp);
      }
      delay = Lee_retraso(&silencio, &secuencia, Ifp, Ofp, dibujofp);
      //fprintf(borrar, "%d %f\n", secuencia, PlayoutDelay);
   }
   
   // Se cierran los ficheros
   if(Ifp) { 
      (void)fclose(Ifp);
   }
   if(Ofp) { 
      (void)fclose(Ofp); 
   }
   if(dibujofp) { 
      (void)fclose(Ofp); 
   }
      
   return 0 ;
}


