#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "algoritmos.h"

int main( int argc, char *argv[] )
{
   FILE    *Ifp, *Ofp, *dibujofp ;            /* I/O File pointers */
   NODO *ldelay;
   float PlayoutDelay;    // Tiempo de estancia en el buffer de playout
   float delay;          // Retraso actual leido del fichero
   float ref_PlayoutDelay;      // Retraso del primer paquete de la rafaga
   int secuencia;

   float silencio = 0;       // Duracion del periodo de silencio
   PlayoutDelay = 0;
   ldelay = NULL;


   if (argc != 4 ) {
      printf("Llamada: %s  fich_retrasos fich_transmitidos fich_dibujo\n", argv[0]);
      exit(1);
   }
   
   Ifp = fopen( argv[1], "r") ;
   if ( Ifp == NULL ) {
      fprintf(stderr, "Invalid input file name: %s\n", argv[1] ) ;
      exit(1) ;
   }

   Ofp = fopen( argv[2], "w") ;
   if ( Ofp == NULL ) {
      fprintf(stderr, "Can't open output file: %s\n", argv[2] ) ;
      exit(1) ;
   } 
   
   dibujofp = fopen( argv[3], "w") ;
   if ( dibujofp == NULL ) {
      fprintf(stderr, "Can't open output file: %s\n", argv[3] ) ;
      exit(1) ;
   }

   //derivadaMos();
   //funcionMos();
   //delay = falseposition(45, 500, 0.0005, 53.8, 5.62);
   //printf("%f\n", delay);
   //return 1;

   delay = Lee_retraso(&silencio, &secuencia, Ifp, Ofp, dibujofp);
   silencio = 0;

   Enlaza_orden(&ldelay, delay);  //Primer nodo de la cola
   Playout_mos(&silencio, ldelay, &PlayoutDelay, &ref_PlayoutDelay, secuencia, dibujofp);
   ref_PlayoutDelay = PlayoutDelay;
   fputs("1 ", Ofp); // Escribe un 1 en el fichero (el primer paquete se recibe a tiempo)

   delay = Lee_retraso(&silencio, &secuencia, Ifp, Ofp, dibujofp);

   // se lee el fichero completo
   //feof: devuelve un valor distinto de cero si ha llegado al final del archivo 
   //ferror: devuelve un valor distinto de cero si se ha producido algun error
   while(!feof(Ifp) && !ferror(Ifp) && !ferror(Ofp)){

      Enlaza_orden(&ldelay, delay);  //Primer nodo de la cola
      Playout_mos(&silencio, ldelay, &PlayoutDelay, &ref_PlayoutDelay, secuencia, dibujofp);
      if (ref_PlayoutDelay >= delay){   // el paquete se recibe a tiempo
         fputs("1 ", Ofp);
      }
      else {                       // el paquete no llega a transmitirse
         fputs("0 ", Ofp);
      }
      delay = Lee_retraso(&silencio, &secuencia, Ifp, Ofp, dibujofp);
   }

   if(Ifp) { 
      (void)fclose(Ifp);
   }
   if(Ofp) { 
      (void)fclose(Ofp); 
   }
   if(dibujofp) { 
      (void)fclose(Ofp); 
   }


   return 1;

}

